<template>
  <v-overlay
    location-strategy="connected"
    absolute
    class="w-fit"
    :scrim="false"
    :location="isMobile ? 'end bottom' : 'bottom center'"
    :origin="isMobile ? 'end top' : 'auto'"
  >
    <template #activator="{ props, isActive }">
      <div v-bind="props">
        <slot name="activator" :isActive="isActive">
          <svn-pro-button text="Activate" />
        </slot>
      </div>
    </template>

    <v-card class="flex flex-col rounded-[8px] w-full card">
      <!-- Tabs -->
      <v-tabs
        v-model="tab"
        bg-color="white"
        color="primary"
        height="48"
        class="!opacity-100 bg-surface"
        :align-tabs="isMobile ? 'center' : 'start'"
        grow
      >
        <!-- Upload tab -->
        <v-tab
          value="upload"
          color="primary"
        >
          <div class="flex px-4 flex-row justify-center items-center gap-2">
            <!-- Icon upload -->
            <div>
              <Icon
                icon="material-symbols:upload"
                :class="tab === 'upload' ? 'text-primary' : 'text-onSurfaceVariant'"
                height="24"
                width="24"
              />
            </div>

            <!-- Text Upload -->
            <svn-pro-text
              medium
              bodyMedium
              :color="tab === 'upload' ? 'onSurface' : 'onSurfaceVariant'"
            >
              {{ 'Upload' }}
            </svn-pro-text>
          </div>
        </v-tab>

        <!-- Embed tab todo: need to be fixed -->
        <v-tab
          value="embed"
          color="primary"
        >
          <div class="flex px-4 flex-row justify-center items-center gap-2">
            <!-- Icon Embed Link -->
            <div>
              <Icon
                icon="mdi:link-variant"
                :class="tab === 'embed' ? 'text-primary' : 'text-onSurfaceVariant'"
                height="24"
                width="24"
              />
            </div>

            <!-- Text Embed Link -->
            <svn-pro-text
              medium
              bodyMedium
              :color="tab === 'embed' ? 'onSurface' : 'onSurfaceVariant'"
            >
              {{ 'Embed link' }}
            </svn-pro-text>
          </div>
        </v-tab>

        <!-- Unsplash tab -->
        <v-tab
          value="unsplash"
          color="primary"
        >
          <div class="flex px-4 flex-row justify-center items-center gap-2">
            <!-- Icon Unsplash -->
            <div>
              <Icon
                icon="mingcute:pic-line"
                :class="tab === 'unsplash' ? 'text-primary' : 'text-onSurfaceVariant'"
                height="24"
                width="24"
              />
            </div>

            <!-- Text Unsplash -->
            <svn-pro-text
              medium
              bodyMedium
              :color="tab === 'unsplash' ? 'onSurface' : 'onSurfaceVariant'"
            >
              {{ 'Unsplash' }}
            </svn-pro-text>
          </div>
        </v-tab>
      </v-tabs>

      <!-- Windows -->
      <v-window
        v-model="tab"
        class="w-full"
      >
        <!-- Upload window -->
        <v-window-item value="upload">
          <div
            class="flex flex-col justify-center items-center w-full"
            :class="isMobile ? 'max-w-[360px] py-8' : 'max-w-[616px] h-[320px] px-6 py-6'"
          >
            <!-- Mobile button -->
            <svn-pro-button
              v-if="isMobile"
              variant="flat"
              text="Upload a file"
              prepend-icon="$vuetify"
              @click="openFilePicker"
            />

            <!-- LargeView -->
            <div
              v-else
              class="flex flex-col w-full h-full justify-center items-center gap-4 rounded-lg border border-dashed border-opacity-100"
              :class="dragActive ? 'bg-surfaceLight border-onSurfaceVariant' : 'bg-surface border-borderColor'"
              @drop.prevent="onDrop"
              @dragenter.prevent="setActiveDrag"
              @dragover.prevent="setActiveDrag"
              @dragleave.prevent="setInactiveDrag"
            >
              <div v-if="!dragActive">
                <Icon
                  icon="material-symbols:upload"
                  class="text-onSurfaceVariant"
                  height="24"
                  width="24"
                />
              </div>

              <svn-pro-text
                regular
                bodyMedium
                color="onSurface"
              >
                {{ dragActive ? 'Drop your file here' : 'Drag & drop here or upload a file' }}
              </svn-pro-text>

              <svn-pro-button
                v-if="!dragActive"
                variant="flat"
                text="Upload a file"
                @click="openFilePicker"
              />
            </div>
          </div>
        </v-window-item>

        <!-- Embed Link window -->
        <v-window-item
          value="embed"
          class="flex flex-col items-end px-4 py-6 gap-4 w-full"
          :class="isMobile ? 'max-w-[360px]' : 'max-w-[616px]'"
        >
          <svn-pro-text-field
            v-model="embedLink"
            variant="outlined"
            class="w-full"
            label="Paste the image link here"
          />

          <svn-pro-button
            variant="flat"
            text="Embed image"
            :disabled="!embedLink?.length"
            @click="uploadImage(embedLink)"
          />
        </v-window-item>

        <!-- Unsplash window -->
        <v-window-item
          value="unsplash"
          class="flex flex-col justify-center items-center pt-6 px-4 gap-6 w-full h-full max-h-[376px]"
          :class="isMobile ? 'max-w-[360px]' : 'max-w-[616px]'"
        >
          <svn-pro-text-field
            v-model="unsplashSearchQuery"
            variant="outlined"
            class="w-full h-full"
            label="Search for an image"
            @update:model-value="search"
          />

          <div
            v-if="loading"
            class="w-full h-[376px] flex items-center justify-center overflo-y-auto"
          >
            <svn-pro-progress-circular
              :width="5"
              indeterminate
            />
          </div>

          <div v-else class="w-full flex flex-col gap-6 overflow-y-auto">
            <!-- Default images -->
            <div
              v-if="!unsplashSearchQuery.length"
              class="h-full flex flex-wrap gap-2 justify-start overflow-y-auto pb-6"
            >
              <div
                v-for="image in unsplashDefaultImages"
                :key="image?.id"
                class="flex flex-col justify-between items-start cursor-pointer max-w-[130px]"
              >
                <div
                  class="rounded w-[130px] h-[80px]"
                  :style="{'background-image': image?.urls?.regular ? `url('${image?.urls?.regular}')` : '', 'background-size': 'cover'}"
                  @click="uploadImage(image?.urls?.regular)"
                />
  
                <svn-pro-text caption class="line-clamp-1">
                  {{ 'By' }}
                  <a
                    class="underline cursor-pointer"
                    :href="`https://unsplash.com/@${image?.user?.username}?utm_source=aleph&utm_medium=referral`"
                  >
                    {{ (image?.user?.first_name || '') + ' ' + (image?.user?.last_name || '') }}
                  </a>
                </svn-pro-text>
              </div>
            </div>

            <div v-else class="w-full flex flex-col">
              <!-- Images after search -->
              <div
                v-if="unsplashSearchImages?.length"
                class="flex flex-wrap gap-2 overflow-y-auto pb-6"
              >
                <div
                  v-for="image in unsplashSearchImages"
                  :key="image?.id"
                  class="flex flex-col justify-between items-start cursor-pointer max-w-[140px]"
                >
                  <div
                    class="rounded w-[140px] h-[80px]"
                    :style="{'background-image': image?.urls?.regular ? `url('${image?.urls?.regular}')` : '', 'background-size': 'cover'}"
                    @click="uploadImage(image?.urls?.regular)"
                  />
    
                  <svn-pro-text caption class="line-clamp-1">
                    {{ 'By' }}
                    <a
                      class="underline cursor-pointer"
                      :href="`https://unsplash.com/@${image?.user?.username}?utm_source=aleph&utm_medium=referral`"
                    >
                      {{ (image?.user?.first_name || '') + ' ' + (image?.user?.last_name || '') }}
                    </a>
                  </svn-pro-text>
                </div>
              </div>

              <!-- Empty state -->
              <div
                v-else
                class="w-full h-full pb-8"
              >
                <svn-pro-empty-states
                  variant="results"
                  :size="isMobile ? 'compact' : 'default'"
                  supporting-text="Oops, we didn't find any results matching your search."
                />
              </div>
            </div>
          </div>
        </v-window-item>
      </v-window>

      <input
        id="file_picker"
        class="w-0 h-0 overflow-hidden opacity-0"
        type="file"
        accept=".jpg,.jpeg,.png,.webp,.gif"
        @change="onFileChange"
      />
    </v-card>
  </v-overlay>
</template>

<script setup>
import { ref, inject, onMounted, onUnmounted } from 'vue';
import { Icon } from '@iconify/vue';
import { createApi } from 'unsplash-js';
import { debounce } from 'lodash';
import SvnProText from '../styles/SvnProText.vue';
import SvnProButton from '../button/SvnProButton.vue';
import SvnProTextField from '../input/SvnProTextField.vue';
import SvnProEmptyStates from '../states/SvnProEmptyStates.vue';
import SvnProProgressCircular from '../progress/SvnProProgressCircular.vue';

const unsplashAccessKey = import.meta.env.VITE_UNSPLASH_ACCESS_KEY || inject('unsplashAccessKey');

const unsplash = createApi({
  accessKey: unsplashAccessKey,
});

onMounted(() => {
  isMobile.value = window.innerWidth < 640
  window.addEventListener("resize", handleWindowResize)

  if (unsplashAccessKey) {
    loading.value = true
    unsplash.photos.list({ perPage: 28 }).then((photos) => {
      if (photos?.errors) {
        console.log("Error fetching Unplash images")
      }
      else {
        unsplashDefaultImages.value = photos?.response?.results
      }
    })
    loading.value = false
  }
  events.value.forEach((eventName) => {
    document.body.addEventListener(eventName, (e) => {
      e.preventDefault()
    })
  })
})

onUnmounted(() => {
  window.removeEventListener("resize", handleWindowResize)
  events.value.forEach((eventName) => {
    document.body.removeEventListener(eventName, (e) => {
      e.preventDefault()
    })
  })
})

const handleWindowResize = (e) => {
  isMobile.value = e.target.innerWidth < 640
}

const emit = defineEmits(['file-uploaded', 'error'])

const isMobile = ref(false)
const dragActive = ref(false)
const draggedFile = ref(null)
const dragTimeout = ref(null)
const loading = ref(true)
const dialogUpload = ref(false)
const tab = ref(null)
const embedLink = ref('')
const unsplashSearchQuery = ref('')
const unsplashDefaultImages = ref([])
const unsplashSearchImages = ref([])
const events = ref(['dragenter', 'dragover', 'dragleave', 'drop'])

const search = () => {
  if (unsplashSearchQuery?.value?.length) {
    loading.value = true
    unsplashSearch()
  }
}

const unsplashSearch = debounce(async() => {
  await unsplash.search.getPhotos({ query: unsplashSearchQuery.value, page: 1, perPage: 28 }).then((photos) => {
    loading.value = false

    if (photos?.errors) {
      console.log("Error fetching Unplash images")
    }
    else {
      if (photos?.response?.results?.length) {
        unsplashSearchImages.value = photos?.response?.results
      }
      else {
        unsplashSearchImages.value = []
      }
    }
  })
}, 300)

const setActiveDrag = () => {
  dragActive.value = true
  clearTimeout(dragTimeout.value)
}

const setInactiveDrag = () => {
  dragActive.value = false
  dragTimeout.value = setTimeout(() => {
    dragActive.value = false
  }, 250)
}

const onDrop = (e) => {
  draggedFile.value = e.dataTransfer.files?.[0]

  if (draggedFile.value) {
    if (new Set(["image/png", "image/jpg", "image/jpeg"]).has(draggedFile.value?.type)) {
      draggedFile.value = URL.createObjectURL(draggedFile.value)
      uploadImage(draggedFile.value)
    }
    else {
      emit('error', 'Error uploading image, wrong image format. Accepted formats are: .jpeg, .jpg, .png')
    }
  }
  setInactiveDrag()
  draggedFile.value = null
}

const uploadImage = async (imageLink) => {
  if (imageLink) {
    emit('file-uploaded', imageLink)
  } else {
    emit('error', 'Error uploading image')
  }
}

const openFilePicker = () => {
  let element = document.getElementById('file_picker')
  if (element) {
    element.click()
  }
}

const onFileChange = (e) => {
  const { files } = e.target;

  if (files && files[0]) {
    const reader = new FileReader();
    reader.onload = (e) => {
      if (getMimeType(e.target.result, files[0].type)) {
        let url = URL.createObjectURL(files[0])
        uploadImage(url)
      } else {
        emit('error', 'Error uploading image')
      }
    };
    reader.readAsArrayBuffer(files[0]);
  }
}

const getMimeType = (file, fallback = null) => {
  const byteArray = (new Uint8Array(file)).subarray(0, 4);
  let header = '';
  for (let i = 0; i < byteArray.length; i++) {
    header += byteArray[i].toString(16);
  }
  switch (header) {
    case "89504e47":
      return "image/png";
    case "47494638":
      return "image/gif";
    case "ffd8ffe0":
    case "ffd8ffe1":
    case "ffd8ffe2":
    case "ffd8ffe3":
    case "ffd8ffe8":
      return "image/jpeg";
    default:
      return fallback;
  }
}

defineExpose({
  dialogUpload
})
</script>

<style scoped>
.card {
  box-shadow: 0px 2px 4px 0px rgba(0, 0, 0, 0.25);
}

::-webkit-scrollbar {
  background-color: transparent;
  width: 13px;
}

/* background of the scrollbar except button or resizer */
::-webkit-scrollbar-track {
  background-color: transparent;
}

/* scrollbar itself */
::-webkit-scrollbar-thumb {
  background-color: #767680;
  border-radius: 16px;
  border: 4px solid #fff;
}

/* set button(top and bottom of the scrollbar) */
::-webkit-scrollbar-button {
  display:none;
}
</style>
